//===============================================================================
// Microsoft Caching Application Block for .NET
// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/dnpag/html/CachingBlock.asp
//
// CacheConfiguration.cs
// Helper class to obtain cache configuration from config file.
//
//===============================================================================
// Copyright (C) 2003 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================


using System;
using System.Collections;
using System.Configuration;
using System.Reflection;
using System.Resources;

// Used for Handling Exceptions
using Microsoft.ApplicationBlocks.ExceptionManagement;

namespace Microsoft.ApplicationBlocks.Cache
{
	#region CacheConfiguration
	/// <summary>
	///	Helper class to obtain cache configuration from config file.
	/// </summary>
	internal class CacheConfiguration
	{
		#region Constant members

		private static CacheConfigurationSettings configSetting;

		#endregion

		#region Constructor
		/// <summary>
		///	The private constructor prevents class from getting created.
		/// </summary>
		private CacheConfiguration() 
		{ 

		}

		#endregion

        #region Properties
		/// <summary>
		///	Gets the cache configuration.
		/// </summary>
		public static CacheConfigurationSettings Config
		{
			get
			{
				if (Object.Equals(configSetting, null))
				{
					configSetting = 
						(CacheConfigurationSettings)ConfigurationSettings.
						GetConfig( CacheResources.ResourceManager[ 
						"RES_CacheManagerSettings" ] );

					if(object.Equals(configSetting, null))
					{
						configSetting = new CacheConfigurationSettings(null,
							null,
							null,
							null);
					}
				}
				return configSetting;
			}
		} 
		#endregion
	}
	#endregion
}
