//=============================================================================
// Copyright  2003 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================


using System;
using System.Xml;
using System.Xml.XPath;
using System.Configuration;

namespace Microsoft.ApplicationBlocks.Common {
    /// <include file='doc\IProvider.uex' path='docs/doc[@for="IProvider"]/*'/>
    /// <devdoc>
    /// Represents the base information for a provider that is a "plug-in" to an application.
    /// </devdoc>
    public interface IProvider {
        /// <include file='doc\IProvider.uex' path='docs/doc[@for="IProvider.Initialize"]/*'/>
        /// <devdoc>
        /// Initializes the provider with custom parameters.
        /// </devdoc>        
        void Initialize(XPathNavigator parameters);
    }
}
