//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// Constructs the DataLoaderManager and exposes its instance as a property
	/// </summary>
	public class DataLoaderManagerBuilder
	{
		private DataLoaderManager dlm;

		/// <summary>
		/// Returns the instance of the DataLoaderManager
		/// </summary>
		public DataLoaderManager DataLoaderManager { get { return dlm; }}

		/// <summary>
		/// Constructor for the DataLoaderManager
		/// </summary>
		/// <param name="referenceDataCache">The reference data cache</param>
		/// <param name="payloadConsumer">The object in the system responsible for enqueuing message payloads. 
		/// This is usually the QueueManager.</param>
		public DataLoaderManagerBuilder(IReferenceDataCache referenceDataCache,
			                            IPayloadConsumer payloadConsumer)
		{
			dlm = new DataLoaderManager(referenceDataCache, payloadConsumer);
		}
	}
}
