//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;
using System.Collections.Specialized;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// Constructs the ServiceAgentManager and exposes it as a series of properties
	/// </summary>
	public class ServiceAgentManagerBuilder
	{
		private ServiceAgentManager serviceAgentManager;
		private ServiceAgentRegistry serviceAgentRegistry;

		/// <summary>
		/// Getter property to expose the ServiceAgentManager instance
		/// </summary>
		public ServiceAgentManager ServiceAgentManager { get { return serviceAgentManager; }}

		/// <summary>
		/// Getter property to expose the ServiceAgentManager as an IResultConsumer. This property should be used by
		/// those wanting to pass Payload execution results to the ServiceAgentManager.
		/// </summary>
		public IResultConsumer ResultConsumer { get { return serviceAgentManager; }}

		/// <summary>
		/// Getter property to expose the ServiceAgentRegistry
		/// </summary>
		internal ServiceAgentRegistry ServiceAgentRegistry { get { return serviceAgentRegistry; }}
		
		/// <summary>
		/// Constructor for ServiceAgentManagerBuilder
		/// </summary>
		public ServiceAgentManagerBuilder()
		{
			serviceAgentRegistry = new ServiceAgentRegistry();
			serviceAgentManager = new ServiceAgentManager(serviceAgentRegistry);
			ServiceAgent.SetServiceAgentRegistry(serviceAgentRegistry);
		}
	}
}
