//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// Exception thrown when the ConnectionManager determines that it is not possible to go online
	/// </summary>
	[Serializable()]
	public class ConnectionUnavailableException : ApplicationException
	{
		/// <summary>
		/// Empty constructor for exception
		/// </summary>
		public ConnectionUnavailableException()
		{
		}

		/// <summary>
		/// Constructor for exception that accepts a message as to why the exception occured
		/// </summary>
		/// <param name="reason">Reason for the exception</param>
		public ConnectionUnavailableException(string reason) : base(reason)
		{	
		}
	}
}
