//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// Enumeration to define connection state. Used by the ConnectionManager to define the physical connectedness
	/// of the system, and by the ServiceAgentManager to define the system-wide connectedness
	/// </summary>

	public enum ConnectionState {
		/// <summary>
			/// <para>  Connection state is Offline</para>
		/// </summary>
		OffLine = 0,
		/// <summary>
			/// <para> Connection state is Online</para>
		/// </summary>
		OnLine = 1,
		/// <summary>
			/// <para> Connection state is Unknown</para>
		/// </summary>
		Unknown = -1
	};
}