//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// This interface defines the methods used to process messages that are taken from the QueueManager. 
	/// It is designed as an extension point that developers can use to alter how messages are handled after being
	/// read from the queue
	/// </summary>
	public interface ICommandProcessor
	{
		/// <summary>
		/// Executes the provided QueueMessage. The assumption is that this call will do everything to ensure
		/// that the message is handled properly.
		/// </summary>
		/// <param name="queueMessage">The message to be processed</param>
		void ExecuteMessage(QueueMessage queueMessage);
	}
}
