//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// This exception is thrown when a MethodProxy-defined method throws an exception during execution
	/// </summary>
	/// 
	[Serializable()]
	public class InvalidOnlineProxyContextDefinitionException : ApplicationException
	{
		/// <summary>
		/// Constructor for exception. It includes the original exception that caused the failure
		/// </summary>
		/// <param name="reason">Reason for raising this exception</param>
		/// <param name="nestedException">Original exception that caused the failure</param>
		public InvalidOnlineProxyContextDefinitionException(string reason, Exception nestedException)
			: base(reason, nestedException)
		{
		}
	}
}
