//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// Defines the interface used to enqueue Payloads to be executed by the Offline Application block
	/// </summary>
	public interface IPayloadConsumer
	{
		/// <summary>
		/// Enqueues the given payload
		/// </summary>
		/// <param name="payloadToEnqueue">Payload to enqueue</param>
		void Enqueue(Payload payloadToEnqueue);
	}
}
