//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// Interface specifying how consumer can get QueueMessages from implementor of this interface,
	/// which will probably be the QueueManager
	/// </summary>
	public interface IQueueMessageProducer
	{
		/// <summary>
		/// Getter property returning the number of messages queued.
		/// </summary>
		/// <value>Number of messages queued</value>
		int Size { get; }

		/// <summary>
		/// Removes and returns a QueueMessage from the queue
		/// </summary>
		/// <returns>Dequeued QueueMessage</returns>
		QueueMessage Dequeue();
	}
}
