//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;
using Microsoft.ApplicationBlocks.Common;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// This class is responsible for creating the pieces necessary to create and initialize the QueueManager
	/// </summary>
	public class QueueManagerConfigurator : ProviderManagerBase
	{
		private IQueueStorageProvider queueStorageProvider;

		/// <summary>
		/// Getter property to get the QueueStorageProvider defined in the configuration file
		/// </summary>
		public IQueueStorageProvider QueueStorageProvider
		{
			get
			{
				if(queueStorageProvider == null)
				{
					IProvider provider = GetProvider("QueueManagerProviders", "queueManagerStorageProvider");
					queueStorageProvider = (IQueueStorageProvider)provider;
				}

				return queueStorageProvider;
			}
		}

		/// <summary>
		/// Constructor for instance.
		/// </summary>
		public QueueManagerConfigurator() : base()
		{
		}
	}
}
