//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// QueueMessage is intended to wrap the application's Payload. This class 
	/// gives us a place to put our own bookkeeping information away from view of the
	/// client code.
	/// </summary>
	/// 
	[Serializable()]
	public class QueueMessage
	{
		private Payload payload;

		/// <summary>
		/// Getter property for retrieving the payload encapsulated by the QueueMessage
		/// </summary>
		/// <value>Payload containing the queue message</value>
		public Payload MessagePayload { get { return payload; }}

		/// <summary>
		/// Constructor for QueueMessage
		/// </summary>
		/// <param name="clientPayload">Payload to be enclosed in this instance</param>
		public QueueMessage(Payload clientPayload)
		{
			payload = clientPayload;
		}

	}
}
