//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// Exception thrown when element not found in ReferenceCache for operations requiring the data to be already resident
	/// </summary>
	/// 
	[Serializable()]
	public class ReferenceCacheElementNotFoundException : ApplicationException
	{
		/// <summary>
		/// Constructor for ReferenceCacheElementNotFoundException
		/// </summary>
		/// <param name="cacheKey">Key of element not found in ReferenceDataCache</param>
		public ReferenceCacheElementNotFoundException(string cacheKey) 
			: base("Operation failed -- '" + cacheKey + "' not found in cache.")
		{
		}
	}
}
