//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// This interface specificies the behavior that is used by the SimpleCommandProcessor to return the data
	/// retrieved from the data source to the original caller in an asynchronous manner
	/// </summary>
	public interface IResultConsumer
	{
		/// <summary>
		/// Called to return the data to the original caller.
		/// </summary>
		/// <param name="payload">The entire message being processed. Should never be null</param>
		void ReturnDataToCaller(Payload payload);
	}
}
