//=============================================================================
// Copyright  2004 Microsoft Corporation
// All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR
// FITNESS FOR A PARTICULAR PURPOSE.
//=============================================================================
using System;

namespace Microsoft.ApplicationBlocks.SmartClient.Offline
{
	/// <summary>
	/// Delegate used to define callback method for this event
	/// </summary>
	/// <param name="sender">Sender of the event</param>/>
	/// <param name="e">Event arguments</param>/>
	public delegate void MethodExecutionFailureReportEventHandler(object sender,
										MethodExecutionFailureReportEventArgs e);

	/// <summary>
	/// EventArgs class for MethodExecutionFailureEvent
	/// </summary>
	public class MethodExecutionFailureReportEventArgs : EventArgs
	{
		private Payload payloadWithFailure;

		/// <summary>
		/// Getter property to retrieve payload with error contained in it.
		/// </summary>
		/// <value>Payload containing error information</value>
		public Payload Payload { get { return payloadWithFailure; }}

		/// <summary>
		/// Constructor for EventArgs class.
		/// </summary>
		/// <param name="payloadWithFailure">Payload containing failure</param>
		public MethodExecutionFailureReportEventArgs(Payload payloadWithFailure)
		{
			this.payloadWithFailure = payloadWithFailure;
		}
	}
}
